﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

"""
 @file MixConsumer.py
 @brief ModuleDescription
 @date $Date$


"""
import sys
import time
sys.path.append(".")

# Import RTM module
import RTC
import OpenRTM_aist

import csv
import traceback
import numpy as np
import os
import locale
import cv2
import copy

from email.mime.text import MIMEText
from twilio.rest import Client

# Your Account Sid and Auth Token from twilio.com/user/account
account_sid = "AC1fd3f7ceab8d4d6d68a087b18aa941d3"
auth_token = "05168a8bc5dc82cada06562f7f0746dd"

client = Client(account_sid, auth_token)


import rect_idl
import elService_idl

# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
import LampRecog, LampRecog__POA
import aqua, aqua__POA


# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
mixconsumer_spec = ["implementation_id", "MixConsumer", 
		 "type_name",         "MixConsumer", 
		 "description",       "ModuleDescription", 
		 "version",           "1.0.0", 
		 "vendor",            "VenderName", 
		 "category",          "Category", 
		 "activity_type",     "STATIC", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 ""]
# </rtc-template>

##
# @class MixConsumer
# @brief ModuleDescription
# 
# 
class MixConsumer(OpenRTM_aist.DataFlowComponentBase):
	
	##
	# @brief constructor
	# @param manager Maneger Object
	# 
	def __init__(self, manager):
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		#self._d_Result = OpenRTM_aist.instantiateDataType(RTC.TimedShortSeq)
                self._d_rec = RTC.TimedShortSeq(RTC.Time(0,0),[])
		"""
		"""
		self._ResultIn = OpenRTM_aist.InPort("Result", self._d_rec)

                #self._d_rec = RTC.TimedShortSeq(RTC.Time(0,0),[])
                #self._ResultIn = OpenRTM_aist.InPort("Result", self._d_Result)

		self._d_eldata = OpenRTM_aist.instantiateDataType(RTC.TimedCharSeq)
		"""
		"""
		self._eldataIn = OpenRTM_aist.InPort("eldata", self._d_eldata)

		"""
		"""
		self._RectServicePort = OpenRTM_aist.CorbaPort("RectService")
		"""
		"""
		self._ElServicePort = OpenRTM_aist.CorbaPort("ElService")

		

		"""
		"""
		self._myService = OpenRTM_aist.CorbaConsumer(interfaceType=LampRecog.lampRect)
		"""
		"""
		self._ElService = OpenRTM_aist.CorbaConsumer(interfaceType=aqua.ElService)

	
	def onInitialize(self):
		# Bind variables and configuration variable
		
		# Set InPort buffers
		self.addInPort("Result",self._ResultIn)
		self.addInPort("eldata",self._eldataIn)
		
		
		self._RectServicePort.registerConsumer("myService", "LampRecog::lampRect", self._myService)
		self._ElServicePort.registerConsumer("ElService", "aqua::ElService", self._ElService)
		
		# Set CORBA Service Ports
		self.addPort(self._RectServicePort)
		self.addPort(self._ElServicePort)

                #add
                self.imgsize = [0,0]
                self.calib = []
                self.threshnum =[[0,0,0,0,0,0,0],[0,0,0,0,0,0,0],[0,0,0,0,0,0,0],[0,0,0,0,0,0,0]] 

                self.list_rects =[]
                self.Rect =[]
                print("initialize")
                call = client.calls.create(
                to="+819026009148",
                from_="+815031878204",
                url="http://ellighttracker2.appspot.com/twilio/voice.xml"
                )

                print(call.sid)
		return RTC.RTC_OK
	

	def onActivated(self, ec_id):
	        #print("activate")
		return RTC.RTC_OK
	

	def onDeactivated(self, ec_id):
                #print("deactivate")
		return RTC.RTC_OK
	

	def onExecute(self, ec_id):
	    if self._ResultIn.isNew():
                self.readSetting()
                print("csv reading")
             #   self._myService._ptr().setParameter(self.imgsize,self.calib,self.threshnum,self.list_rects)

            #output
                self._d_Result = self._ResultIn.read()
                data = self._d_Result.data
                num = len(data) / 4
            
           # print("str:"+str(num))

                for i in range(0,num):
                    print(str(data[i*4])+","+str(data[i*4+1])+","+str(data[i*4+2])+","+str(data[i*4+3]))

            #output 
            if self._eldataIn.isNew():
                    a = self._eldataIn.read()
                    print(a.data)

               #     threshould = "0xf000"

                    phonenumber = "+819026009148"
 
		    print "change phoneNumber??"
		    c = raw_input()
		    if c == 'yes':
                             retnum = self._ElService._ptr().write_num(phonenumber)
                             print ("change phone Number", phonenumber, ")" ) 
            return RTC.RTC_OK
	
        def readSetting(self):
            print("read")
            with open('./data/setting.csv', 'r') as f:
                csvdata = csv.reader(f)
#string read
                data_csv = [ x for x in csvdata ]
#int convert
                data = [[int(elm) for elm in v] for v in data_csv]

#print("data:"+str(data))
                self.imgsize[0] = data[0][0]
                self.imgsize[1] = data[0][1]

                self.calib = [  [   data[1][0], data[1][1],
                                    data[2][0], data[2][1],
                                    data[3][0], data[3][1],
                                    data[4][0], data[4][1]],
                                [   data[5][0], data[5][1],
                                    data[6][0], data[6][1],
                                    data[7][0], data[7][1],
                                    data[8][0], data[8][1]] ]

            print("self.calib"+str(self.calib))
#read threshold line 9 -> 12 (4 item)
            for i in range(4):
                for j in range(7):
                    self.threshnum[i][j] = data[9+i][j]
            print("self.threshnum:"+str(self.threshnum))
                                    
#clear list_rect 
            del self.list_rects[:]
            list_num = data[13][0]
            print("list_num"+str(list_num))
            print("middle")
            self.list_rects = data[14]
            print("end")
            print("list_rects"+str(self.list_rects))
       #     for i in range(0,list_num):
       #         for j in range(4):
       #             self.list_rects.append(data[i+14][j])


def MixConsumerInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=mixconsumer_spec)
    manager.registerFactory(profile,
                            MixConsumer,
                            OpenRTM_aist.Delete)

def MyModuleInit(manager):
    MixConsumerInit(manager)

    # Create a component
    comp = manager.createComponent("MixConsumer")

def main():
	mgr = OpenRTM_aist.Manager.init(sys.argv)
	mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
	mgr.runManager()

if __name__ == "__main__":
	main()

